<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] ?: array()) + array("_b06968b9268deaf3b380bd0fe922b" . "453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbC" . "BXSEVSRSBvYmplY3RfY29kZSBlcTpz" . "dHI6Y29kZSBBTkQgdXNlcl9pZD1pbn" . "Q6dWlk"), "_84718d828d2acc3c" . "366f96b07e841f6a" => base64_decode("YWNs" . "LnNp" . "bXBs" . "ZQ=="), "_3cda3f34ada928e4aa39d4629c5" . "504aa" => base64_decode("aW50OnJpZ2h0cw=" . "="), "_938704c4c0169c380" . "4d4bd6aa9941a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9" . "iamVjdCBjb2RlIG5vdCBzcG" . "VjaWZpZWQ="), "_a8b22fedb27a11e07f5bb9a7c73608e" . "a" => base64_decode("c3RyKDEw" . "MCk6b2Jq" . "ZWN0X2Nv" . "ZGU="), "_ef2948c87ef38aab9226e41189b29ca" . "7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI" . "6Y29kZQ=="), "_80fc2a45acd" . "0150df87d1fb" . "728940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5EIHVzZXJfaWQ9aW50OnVpZ" . "A=="), "_27de5a45" . "db71bf240" . "58769b61b" . "3975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vd" . "CBzcGVjaWZpZWQ="), "_0877a0b48cf424a0d" . "e57a453ce95e30c" => base64_decode("aW50OnV" . "zZXJfaW" . "Q="), "_dbbe14f567693a631f8a43" . "b65af917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhd" . "GFiYXNlOiBvYmplY3QgY29kZSBub3Qgc3" . "BlY2lmaWVk"), "_a7ed4d7408bb99b87a09d89d4" . "212d5de" => base64_decode("c2ltcGxlX2" . "FjbA=="), "_c95cbc3" . "16178c97" . "697a403f" . "4d912410" . "6" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZ" . "XE6c3RyOmNvZGU="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_84718d828d2" . "acc3c366f96b" . "07e841f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_80fc2a45acd" . "0150df87d1fb" . "728940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_a7ed4d740" . "8bb99b87a0" . "9d89d4212d" . "5de"], [$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_a8b22fedb27" . "a11e07f5bb9a" . "7c73608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_0877a0b48cf424a0de57a453ce" . "95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_3cda3f34ada928e" . "4aa39d4629c5504a" . "a"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_b06968b9268de" . "af3b380bd0fe92" . "2b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_938704c4c0169c3804d4bd6aa" . "9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_c95cbc316178c97697a403f4d912" . "4106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_27de5a45db71b" . "f24058769b61b3" . "975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_dbbe14f567693a631f8a43b65af917a" . "b"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_ef2948c87ef38aab9226e41189b29c" . "a7"], $acl->GetObjectCode());
    }
}